// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package group

import (
	"context"
	"demo/internal/model/entity"
	"sync"
)

// Ensure, that IRepositoryMock does implement IRepository.
// If this is not the case, regenerate this file with moq.
var _ IRepository = &IRepositoryMock{}

// IRepositoryMock is a mock implementation of IRepository.
//
// 	func TestSomethingThatUsesIRepository(t *testing.T) {
//
// 		// make and configure a mocked IRepository
// 		mockedIRepository := &IRepositoryMock{
// 			GetActiveByIDFunc: func(ctx context.Context, id string) (*entity.Group, error) {
// 				panic("mock out the GetActiveByID method")
// 			},
// 			ListActiveFunc: func(ctx context.Context, limit int64, offset int64) ([]*entity.Group, error) {
// 				panic("mock out the ListActive method")
// 			},
// 			RemoveFunc: func(ctx context.Context, id string) error {
// 				panic("mock out the Remove method")
// 			},
// 			SaveFunc: func(ctx context.Context, obj *entity.Group) error {
// 				panic("mock out the Save method")
// 			},
// 			SetDefaultFunc: func(ctx context.Context, id string, isDefault bool) (*entity.Group, error) {
// 				panic("mock out the SetDefault method")
// 			},
// 			UpdateMapFunc: func(ctx context.Context, id string, obj map[string]interface{}) (*entity.Group, error) {
// 				panic("mock out the UpdateMap method")
// 			},
// 		}
//
// 		// use mockedIRepository in code that requires IRepository
// 		// and then make assertions.
//
// 	}
type IRepositoryMock struct {
	// GetActiveByIDFunc mocks the GetActiveByID method.
	GetActiveByIDFunc func(ctx context.Context, id string) (*entity.Group, error)

	// ListActiveFunc mocks the ListActive method.
	ListActiveFunc func(ctx context.Context, limit int64, offset int64) ([]*entity.Group, error)

	// RemoveFunc mocks the Remove method.
	RemoveFunc func(ctx context.Context, id string) error

	// SaveFunc mocks the Save method.
	SaveFunc func(ctx context.Context, obj *entity.Group) error

	// SetDefaultFunc mocks the SetDefault method.
	SetDefaultFunc func(ctx context.Context, id string, isDefault bool) (*entity.Group, error)

	// UpdateMapFunc mocks the UpdateMap method.
	UpdateMapFunc func(ctx context.Context, id string, obj map[string]interface{}) (*entity.Group, error)

	// calls tracks calls to the methods.
	calls struct {
		// GetActiveByID holds details about calls to the GetActiveByID method.
		GetActiveByID []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// ID is the id argument value.
			ID string
		}
		// ListActive holds details about calls to the ListActive method.
		ListActive []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Limit is the limit argument value.
			Limit int64
			// Offset is the offset argument value.
			Offset int64
		}
		// Remove holds details about calls to the Remove method.
		Remove []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// ID is the id argument value.
			ID string
		}
		// Save holds details about calls to the Save method.
		Save []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Obj is the obj argument value.
			Obj *entity.Group
		}
		// SetDefault holds details about calls to the SetDefault method.
		SetDefault []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// ID is the id argument value.
			ID string
			// IsDefault is the isDefault argument value.
			IsDefault bool
		}
		// UpdateMap holds details about calls to the UpdateMap method.
		UpdateMap []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// ID is the id argument value.
			ID string
			// Obj is the obj argument value.
			Obj map[string]interface{}
		}
	}
	lockGetActiveByID sync.RWMutex
	lockListActive    sync.RWMutex
	lockRemove        sync.RWMutex
	lockSave          sync.RWMutex
	lockSetDefault    sync.RWMutex
	lockUpdateMap     sync.RWMutex
}

// GetActiveByID calls GetActiveByIDFunc.
func (mock *IRepositoryMock) GetActiveByID(ctx context.Context, id string) (*entity.Group, error) {
	if mock.GetActiveByIDFunc == nil {
		panic("IRepositoryMock.GetActiveByIDFunc: method is nil but IRepository.GetActiveByID was just called")
	}
	callInfo := struct {
		Ctx context.Context
		ID  string
	}{
		Ctx: ctx,
		ID:  id,
	}
	mock.lockGetActiveByID.Lock()
	mock.calls.GetActiveByID = append(mock.calls.GetActiveByID, callInfo)
	mock.lockGetActiveByID.Unlock()
	return mock.GetActiveByIDFunc(ctx, id)
}

// GetActiveByIDCalls gets all the calls that were made to GetActiveByID.
// Check the length with:
//     len(mockedIRepository.GetActiveByIDCalls())
func (mock *IRepositoryMock) GetActiveByIDCalls() []struct {
	Ctx context.Context
	ID  string
} {
	var calls []struct {
		Ctx context.Context
		ID  string
	}
	mock.lockGetActiveByID.RLock()
	calls = mock.calls.GetActiveByID
	mock.lockGetActiveByID.RUnlock()
	return calls
}

// ListActive calls ListActiveFunc.
func (mock *IRepositoryMock) ListActive(ctx context.Context, limit int64, offset int64) ([]*entity.Group, error) {
	if mock.ListActiveFunc == nil {
		panic("IRepositoryMock.ListActiveFunc: method is nil but IRepository.ListActive was just called")
	}
	callInfo := struct {
		Ctx    context.Context
		Limit  int64
		Offset int64
	}{
		Ctx:    ctx,
		Limit:  limit,
		Offset: offset,
	}
	mock.lockListActive.Lock()
	mock.calls.ListActive = append(mock.calls.ListActive, callInfo)
	mock.lockListActive.Unlock()
	return mock.ListActiveFunc(ctx, limit, offset)
}

// ListActiveCalls gets all the calls that were made to ListActive.
// Check the length with:
//     len(mockedIRepository.ListActiveCalls())
func (mock *IRepositoryMock) ListActiveCalls() []struct {
	Ctx    context.Context
	Limit  int64
	Offset int64
} {
	var calls []struct {
		Ctx    context.Context
		Limit  int64
		Offset int64
	}
	mock.lockListActive.RLock()
	calls = mock.calls.ListActive
	mock.lockListActive.RUnlock()
	return calls
}

// Remove calls RemoveFunc.
func (mock *IRepositoryMock) Remove(ctx context.Context, id string) error {
	if mock.RemoveFunc == nil {
		panic("IRepositoryMock.RemoveFunc: method is nil but IRepository.Remove was just called")
	}
	callInfo := struct {
		Ctx context.Context
		ID  string
	}{
		Ctx: ctx,
		ID:  id,
	}
	mock.lockRemove.Lock()
	mock.calls.Remove = append(mock.calls.Remove, callInfo)
	mock.lockRemove.Unlock()
	return mock.RemoveFunc(ctx, id)
}

// RemoveCalls gets all the calls that were made to Remove.
// Check the length with:
//     len(mockedIRepository.RemoveCalls())
func (mock *IRepositoryMock) RemoveCalls() []struct {
	Ctx context.Context
	ID  string
} {
	var calls []struct {
		Ctx context.Context
		ID  string
	}
	mock.lockRemove.RLock()
	calls = mock.calls.Remove
	mock.lockRemove.RUnlock()
	return calls
}

// Save calls SaveFunc.
func (mock *IRepositoryMock) Save(ctx context.Context, obj *entity.Group) error {
	if mock.SaveFunc == nil {
		panic("IRepositoryMock.SaveFunc: method is nil but IRepository.Save was just called")
	}
	callInfo := struct {
		Ctx context.Context
		Obj *entity.Group
	}{
		Ctx: ctx,
		Obj: obj,
	}
	mock.lockSave.Lock()
	mock.calls.Save = append(mock.calls.Save, callInfo)
	mock.lockSave.Unlock()
	return mock.SaveFunc(ctx, obj)
}

// SaveCalls gets all the calls that were made to Save.
// Check the length with:
//     len(mockedIRepository.SaveCalls())
func (mock *IRepositoryMock) SaveCalls() []struct {
	Ctx context.Context
	Obj *entity.Group
} {
	var calls []struct {
		Ctx context.Context
		Obj *entity.Group
	}
	mock.lockSave.RLock()
	calls = mock.calls.Save
	mock.lockSave.RUnlock()
	return calls
}

// SetDefault calls SetDefaultFunc.
func (mock *IRepositoryMock) SetDefault(ctx context.Context, id string, isDefault bool) (*entity.Group, error) {
	if mock.SetDefaultFunc == nil {
		panic("IRepositoryMock.SetDefaultFunc: method is nil but IRepository.SetDefault was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		ID        string
		IsDefault bool
	}{
		Ctx:       ctx,
		ID:        id,
		IsDefault: isDefault,
	}
	mock.lockSetDefault.Lock()
	mock.calls.SetDefault = append(mock.calls.SetDefault, callInfo)
	mock.lockSetDefault.Unlock()
	return mock.SetDefaultFunc(ctx, id, isDefault)
}

// SetDefaultCalls gets all the calls that were made to SetDefault.
// Check the length with:
//     len(mockedIRepository.SetDefaultCalls())
func (mock *IRepositoryMock) SetDefaultCalls() []struct {
	Ctx       context.Context
	ID        string
	IsDefault bool
} {
	var calls []struct {
		Ctx       context.Context
		ID        string
		IsDefault bool
	}
	mock.lockSetDefault.RLock()
	calls = mock.calls.SetDefault
	mock.lockSetDefault.RUnlock()
	return calls
}

// UpdateMap calls UpdateMapFunc.
func (mock *IRepositoryMock) UpdateMap(ctx context.Context, id string, obj map[string]interface{}) (*entity.Group, error) {
	if mock.UpdateMapFunc == nil {
		panic("IRepositoryMock.UpdateMapFunc: method is nil but IRepository.UpdateMap was just called")
	}
	callInfo := struct {
		Ctx context.Context
		ID  string
		Obj map[string]interface{}
	}{
		Ctx: ctx,
		ID:  id,
		Obj: obj,
	}
	mock.lockUpdateMap.Lock()
	mock.calls.UpdateMap = append(mock.calls.UpdateMap, callInfo)
	mock.lockUpdateMap.Unlock()
	return mock.UpdateMapFunc(ctx, id, obj)
}

// UpdateMapCalls gets all the calls that were made to UpdateMap.
// Check the length with:
//     len(mockedIRepository.UpdateMapCalls())
func (mock *IRepositoryMock) UpdateMapCalls() []struct {
	Ctx context.Context
	ID  string
	Obj map[string]interface{}
} {
	var calls []struct {
		Ctx context.Context
		ID  string
		Obj map[string]interface{}
	}
	mock.lockUpdateMap.RLock()
	calls = mock.calls.UpdateMap
	mock.lockUpdateMap.RUnlock()
	return calls
}
